.model tiny
.code
.386
mode    struc
        flag    db 0
        num     dw 0
        resx    dw 0
        resy    dw 0
        attr    db 0
mode    ends

       db 'EOSDRV'
       db 0,1
       dw 64
       db 'VIDS'
       dw 64
       org 10h
       db 'Copyright (c) 1998 EXOS Technologies'
       org 64


driver:
       cmp ax,0h
       jne d0
       call mputpixel
       retf
d0:
       cmp ax,1h
       jne d1
       call mgetpixel
       retf
d1:
       cmp ax,2h
       jne d2
       call swapbank
       retf
d2:
       cmp ax,10h
       jne d10
       call setvmode
       retf
d10:
       retf

swapbank:
      push bx
      mov dx,ax
      push dx
      xor bx,bx           ;set frame no.0
      mov ax,4f05h        ;VESA frame function
      int 10h

      pop dx              ;restore bank
      mov bx,01           ;set frame no.1
      mov ax,4f05h        ;VESA frame function
      int 10h

      mov ax,0A000h
      mov es,ax
      pop bx
      ret

mputpixel:  ;256 color modes ;CX,DX = pixel  BX = color
     push eax si edx es
     movzx eax,cs:word ptr maxx
     mul edx             ;eDX  뢠
     add eax,ecx
     xor edx,edx
     div cs:dword ptr banksize
     mov si,dx
     call swapbank
     mov es:[si],bx
     pop es edx si eax
     ret

mgetpixel:  ;256 color modes ;CX,DX = pixel  >>BX = color
     push eax si edx es
     movzx eax,cs:word ptr maxx
     mul edx             ;eDX  뢠
     add eax,ecx
     xor edx,edx
     div cs:dword ptr banksize
     mov si,dx
     call swapbank
     mov bx,es:[si]
     pop es edx si eax
     ret

;0 = B/W
;1 = 2 color
;2 = 4 color
;3 = 8 color
;4 = 16 color
;6 = 64 color
;8 = 256 color
;15 = 32K
;16 = 64K
;24 = 16.8M

setvmode:    ;CX,DX = Resolution Bl = Attribute
     push si
     mov ax,23
     lea si,modetable
dm1:
     cmp cx,cs:[si+3]
     jne dm2
     cmp dx,cs:[si+5]
     jne dm2
     cmp bl,cs:[si+7]
     jne dm2
     cmp cs:byte ptr [si+0],1
     je dm3
dm2:
     dec ax
     add si,8
     cmp ax,0
     jne dm1
     mov ax,1 ;Mode not supported
     pop si
     ret
dm3:
     mov bx,cs:[si+1]
     pop si
     mov ax,4f02h
     int 10h
     cmp ah,00
     je dm4
     mov ax,2 ;Hardware error
     ret
dm4:
     xor ax,ax ;No errors
     pop si
     ret

;----------------------Variables----------------------------------------------
maxx: dw 0    ;not init !!!!!!!!!!
maxy: dw 0
banksize: dd 0



modetable:
mode <0,100h,640,400,8>;         640x400    256
mode <0,101h,640,480,8>;         640x480    256
mode <0,102h,800,600,4>;         800x600    16
mode <0,103h,800,600,8>;         800x600    256
mode <0,104h,1024,768,4>;        1024x768   16
mode <0,105h,1024,768,8>;        1024x768   256
mode <0,106h,1280,1024,4>;       1280x1024  16
mode <0,107h,1280,1024,8>;       1280x1024  256
mode <0,10Dh,320,200,15>;        320x200    32K
mode <0,10Eh,320,200,16>;        320x200    64K
mode <0,10Fh,320,200,24>;        320x200    16.8M
mode <0,110h,640,480,15>;        640x480    32K
mode <0,111h,640,480,16>;        640x480    64K
mode <0,112h,640,480,24>;        640x480    16.8M
mode <0,113h,800,600,15>;        800x600    32K
mode <0,114h,800,600,16>;        800x600    64K
mode <0,115h,800,600,24>;        800x600    16.8M
mode <0,116h,1024,768,15>;       1024x768   32K
mode <0,117h,1024,768,16>;       1024x768   64K
mode <0,118h,1024,768,24>;       1024x768   16.8M
mode <0,119h,1280,1024,15>;      1280x1024  32K
mode <0,11Ah,1280,1024,16>;      1280x1024  64K
mode <0,11Bh,1280,1024,24>;      1280x1024  16.8M

     end